/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <string>

#define N_MAX 1000

struct point {
    point(int xi = -1, int yi = -1) {
        x = xi;
        y = yi;
    }

    int x;
    int y;
};

struct square {
    square() {
        clean = true;
    }

    point topleft;
    point bottomright;
    bool clean;
};

bool plot[N_MAX][N_MAX];
square one, two;

using namespace std;

void out()
{
    bool oneFirst = true;
    if (one.topleft.x < two.topleft.x) {
        oneFirst = true;
    } else if (one.topleft.x > two.topleft.x) {
        oneFirst = false;
    } else {
        if (one.topleft.y < two.topleft.y) {
            oneFirst = true;
        } else if (one.topleft.y > two.topleft.y) {
            oneFirst = false;
        } else {
            if (one.bottomright.x < two.bottomright.x) {
                oneFirst = true;
            } else if (one.bottomright.x > two.bottomright.x) {
                oneFirst = false;
            } else {
                oneFirst = true;
            }
        }
    }

    if (oneFirst) {
        printf("%d %d %d %d\n", one.topleft.x+1, one.topleft.y+1, one.bottomright.x+1, one.bottomright.y+1);
        printf("%d %d %d %d\n", two.topleft.x+1, two.topleft.y+1, two.bottomright.x+1, two.bottomright.y+1);
    } else {
        printf("%d %d %d %d\n", two.topleft.x+1, two.topleft.y+1, two.bottomright.x+1, two.bottomright.y+1);
        printf("%d %d %d %d\n", one.topleft.x+1, one.topleft.y+1, one.bottomright.x+1, one.bottomright.y+1);
    }
}

int main()
{
    freopen("squares.in", "r", stdin);
    freopen("squares.out", "w", stdout);
    memset(plot, 0, sizeof(plot));

    int n = 0;
    scanf("%d\n", &n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            char c;
            scanf("%c ", &c);
            if (c == '#')
                plot[i][j] = true;
        }
        scanf("\n");
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (!plot[i][j])
                continue;

            // Point belongs to existing square
            if ((i >= one.topleft.y && i <= one.bottomright.y &&
                 j >= one.topleft.x && j <= one.bottomright.x) ||
                (i >= two.topleft.y && i <= two.bottomright.y &&
                 j >= two.topleft.x && j <= two.bottomright.x)) {
                continue;
            }

            // Looking for width
            int width = -1, mx = i;
            while (plot[mx][j] && mx < n) {
                width++;
                mx++;
            }

            // Looking for height
            int height = -1, my = j;
            while (plot[i][my] && my < n) {
                height++;
                my++;
            }

            int side;
            side = (width > height) ? height : width;

            if (one.clean) {
                one.topleft = point(j, i);
                one.bottomright = point(j+side, i+side);
                one.clean = false;
            } else {
                two.topleft = point(j, i);
                two.bottomright = point(j+side, i+side);
                two.clean = false;

                out();
                return 0;
            }
        }
    }

    if (two.clean) {
        two = one;
        out();
    }

    return 0;
}
