/* GCC */
#include<iostream>
#include<fstream>
#include<cmath>
#include<vector>
using namespace std;
struct Coordinates {
    int x_;
    int y_;
    friend bool operator>(Coordinates a, Coordinates b);
    friend bool operator==(Coordinates a, Coordinates b);
    Coordinates() {
        x_=-1;
        y_=-1;
    }
    Coordinates(int x, int y) {
        x_=x;
        y_=y;
    }
};
bool operator==(Coordinates a, Coordinates b) {
    return a.x_==b.x_ && a.y_==b.y_;
}
bool operator>(Coordinates a, Coordinates b) {
    return a.x_>b.x_ || (a.x_==b.x_ && a.y_>b.y_);
}
void sortArr(vector<vector<Coordinates> > &a) {
    if(a[0][0]>a[1][0] || (a[0][0]==a[1][0] && a[0][1]>a[1][1])) {
        swap(a[0], a[1]);
    }
}

bool isSquare(Coordinates &a, Coordinates &b) {
    if(abs(b.x_-a.x_)==abs(int(b.y_)-a.y_) && abs(b.x_-a.x_)>=2 && a.x_!=-1 && b.x_!=-1) {
        return true;
    }
    else {
        return false;
    }
}
void removeFromVector(unsigned int id, vector<vector<Coordinates> > &a) {
    for(int i=id;i<a.size()-1;i++) {
        a[i]=a[i+1];
    }
    a.pop_back();
}
bool isTop(Coordinates a, vector<vector<bool> > &paper) {
    if(paper[a.y_+1][a.x_] && paper[a.y_][a.x_+1] && paper[a.y_][a.x_]) return true;
    else return false;
}
bool isBottom(Coordinates a, vector<vector<bool> > &paper) {
    if(paper[a.y_-1][a.x_] && paper[a.y_][a.x_-1] && paper[a.y_][a.x_]) return true;
    else return false;
}
int main() {
    ifstream fin;
    unsigned int n;
    fin.open("squares.in");
    fin>>n;
    vector<vector<bool> > paper;
    char symb;
    for(unsigned int i=0; i<n;i++) {
        paper.push_back(vector<bool>());
        for(unsigned int j=0;j<n;j++) {
            fin>>symb;
            paper[i].push_back(symb=='#');
        }
    }
    fin.close();
    vector<vector<Coordinates> > topes;
    int topesCount=0;
    for(unsigned int i=0;i<n-2;i++) {
        for(unsigned int j=0;j<n-2;j++) {
            if(isTop(Coordinates(j, i), paper)) {
                topes.push_back(vector<Coordinates>(2));
                topes[topesCount][0].x_=j;
                topes[topesCount][0].y_=i;
                topesCount++;
            }
        }
    }
    int bottomsCount=0;
    for(unsigned int i=n-1;i>=2;i--) {
        for(unsigned int j=n-1;j>=2;j--) {
            if(isBottom(Coordinates(j, i), paper)) {
                if(bottomsCount>=topesCount) {
                    topes.push_back(vector<Coordinates>(2));
                    topes[bottomsCount][1].x_=j;
                    topes[bottomsCount][1].y_=i;
                }
                topes[bottomsCount][1].x_=j;
                topes[bottomsCount][1].y_=i;
                bottomsCount++;
            }
        }
    }
    if(topesCount>=bottomsCount) {
        for(unsigned int i=0;i<topes.size(); i++) {
            bool isFound=false;
            for(unsigned int j=i;j<topes.size() && !isFound;j++) {
                if(isSquare(topes[j][0], topes[i][1])) {
                    Coordinates temp=topes[i][0];
                    topes[i][0]=topes[j][0];
                    topes[j][0]=temp;
                    isFound=true;
                }
            }
            if(!isFound) {
                removeFromVector(i, topes);
                continue;
            }
        }
    }
    else {
        for(unsigned int i=0;i<topes.size(); i++) {
            bool isFound=false;
            for(unsigned int j=i;j<topes.size() && !isFound;j++) {
                if(isSquare(topes[i][0], topes[j][1])) {
                    Coordinates temp=topes[i][1];
                    topes[i][1]=topes[j][1];
                    topes[j][1]=temp;
                    isFound=true;
                }
            }
            if(!isFound) {
                removeFromVector(i, topes);
                continue;
            }
        }
    }
    while(topes.size()>2) {
        topes.pop_back();
    }
    sortArr(topes);
    ofstream fout;
    fout.open("squares.out");
    for(int i=0;i<2;i++) {
        for(int j=0;j<2;j++) {
            fout<<topes[i][j].x_+1<<" "<<topes[i][j].y_+1<<" ";
        }
        fout<<"\n";
    }
    fout.close();
    return 0;
}
