/* GCC */

#include <fstream>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

void Qsort(unsigned long long* p, int left, int right)
{
    int l = left;
    int r = right;
    unsigned long long m = p[(l+r)/2];
    do
    {
        while (p[l] < m) l++;
        while (p[r] > m) r--;
        if (l<=r)
        {
            int t = p[l];
            p[l] = p[r];
            p[r] = t;
            l++;
            r--;
        }
    }
    while (l<=r);
    if (left < r) Qsort(p, left, r);
    if (l < right) Qsort(p, l, right);

}


bool Bsearch(unsigned long long* p, unsigned long long num, int &start, int ed)
{
    int i;
    for (i=start; i<ed  && p[i] <= num; ++i)
        if (p[i] == num)
        {
            start = i+1;
            return true;
        }
    start = i;
    return false;
}
int main()
{
    ifstream fin("heels.in");
    ofstream fout("heels.out");
    int n = 0;
    fin >> n;
    unsigned long long* n1 = new unsigned long long[n];
    unsigned long long* n2 = new unsigned long long[n];
    for (int i=0;i<n;++i)
        fin >> n1[i];
    for (int i=0;i<n;++i)
        fin >> n2[i];
    Qsort(n1, 0, n-1);
    Qsort(n2, 0, n-1);
    int st = 0, ct = 0;
    for (int i=0;i<n;++i)
        if (Bsearch(n2, n1[i], st, n)) ct++;
    fout << ct;
    fin.close();
    fout.close();
    delete[] n1;
    delete[] n2;
    return 0;
}
