/* GCC */

#include <windows.h>
#include <iostream.h>
#include <fstream.h>

using namespace std;

int sq1x,sq1y,sq1x2,sq1y2;
int sq2x,sq2y,sq2x2,sq2y2;
int N;
bool A[1000][1000];

bool BelongsTo1stSq(int X, int Y)
{
    if (X >= sq1x && X <= sq1x2 && Y >= sq1y && Y <= sq1y2)//outer
        if (!(X >= sq1x+1 && X <= sq1x2-1 && Y >= sq1y+1 && Y <= sq1y2-1))//inner
            return true;

    return false;
}
bool BelongsTo2ndSq(int X, int Y)
{
    if (X >= sq2x && X <= sq2x2 && Y >= sq2y && Y <= sq2y2)//outer
        if (!(X >= sq2x+1 && X <= sq2x2-1 && Y >= sq2y+1 && Y <= sq2y2-1))//inner
            return true;

    return false;
}
bool AllTilesUsed()
{
    bool error = false;
    for (int X = 0; X < N; X++)
    {
        for (int Y = 0; Y < N; Y++)
        {
            if (A[X][Y])
                if (!(BelongsTo1stSq(X,Y) || BelongsTo2ndSq(X,Y)))
                {
                    error = true; break;
                }
        }
        if (error) break;
    }

    return !error;
}

int main()
{
    char Ch;
    ifstream fin("squares.in",std::ios_base::in);
    fin >> N;

    for (int Y = 0; Y < N; Y++)
        for (int X = 0; X < N; X++)
    {
        A[X][Y] = false;
        fin >> Ch;
        if (Ch == '#') A[X][Y] = true;
    }

    fin.close();

    //find sq 1 start
    sq1x = -1,sq1y = -1;
    for (int X = 0; X < N; X++)
    {
        for (int Y = 0; Y < N; Y++)
        {
            if (A[X][Y])
            {
                sq1x = X; sq1y = Y;
                break;
            }
        }
        if (sq1x != -1) break;
    }

    //find sq 1 end
    sq1x2 = sq1x,sq1y2 = sq1y;

    while (sq1x2 < N && sq1y2 < N)
    {
        if (A[sq1x2+1][sq1y] && A[sq1x][sq1y2+1])
        {
            sq1x2++; sq1y2++;
        }
        else break;
    }

    //if sq1 and sq2 are the same
    bool Success = AllTilesUsed();
    if (Success)
    {
        ofstream fout("squares.out",std::ios_base::out);
        fout << sq1x+1 << ' ' << sq1y+1 << ' ' << sq1x2+1 << ' ' << sq1y2+1 << endl;
        fout << sq1x+1 << ' ' << sq1y+1 << ' ' << sq1x2+1 << ' ' << sq1y2+1 << endl;
        fout.close();

        return 0;
    }

    //find suitable top-left and bottom-right edges for sq 2
    int XUsed[10] = {-1};
    int YUsed[10] = {-1};
    int top = 0;//first edge (-1;-1) is already pushed as 0


    while(!Success)
    {
        //pick a top-left edge

        sq2x = -1; sq2y = -1;
        for (int X = 0; X < N; X++)
        {
            for (int Y = 0; Y < N; Y++)
            {
                if (A[X][Y])
                    if (A[X+1][Y] && A[X][Y+1])//if it's an edge
                    {
                        bool used = false;
                        for (int q = 0; q <= top; q++)
                            if (X == XUsed[q] && Y == YUsed[q])
                                used = true;

                        if (!used)
                        {
                            sq2x = X; sq2y = Y;
                            //push
                            XUsed[++top] = X;
                            YUsed[top] = Y;
                            break;
                        }
                    }
            }

            if (sq2x != -1) break;
        }

        sq2x2 = sq2x; sq2y2 = sq2y;
        //bool CantExpand = false;
        while (sq2x2 < N && sq2y2 < N)
        {
            if (A[sq2x2+1][sq2y] && A[sq2x][sq2y2+1])
            {
                sq2x2++; sq2y2++;
            }
            else break;
            //if the square can be joined and at least 1 tile is new
            if (A[sq2x2][sq2y+1] && A[sq2x+1][sq2y2])
                if (!BelongsTo1stSq(sq2x2,sq2y+1) || !BelongsTo1stSq(sq2x+1,sq2y2))
                    Success = AllTilesUsed();

            if (Success) break;
        }
    }

    //output

    bool First = 0;
    if (sq1x == sq2x)
    {
        if (sq1y == sq2y)
        {
            if (sq1x2 == sq2x2)
            {
                if (sq1y2 == sq2y2)
                    First = 1;
                else if (sq1y2 > sq2y2)
                    First = 1;
            }
            else if (sq1x2 > sq2x2)
                First = 1;
        }
        else if (sq1y > sq2y)
            First = 1;
    }
    else if (sq1x > sq2x)
        First = 1;

    ofstream fout("squares.out",std::ios_base::out);
    if (First == 0)
    {
        fout << sq1x+1 << ' ' << sq1y+1 << ' ' << sq1x2+1 << ' ' << sq1y2+1 << endl;
        fout << sq2x+1 << ' ' << sq2y+1 << ' ' << sq2x2+1 << ' ' << sq2y2+1 << endl;
    }
    else
    {
        fout << sq2x+1 << ' ' << sq2y+1 << ' ' << sq2x2+1 << ' ' << sq2y2+1 << endl;
        fout << sq1x+1 << ' ' << sq1y+1 << ' ' << sq1x2+1 << ' ' << sq1y2+1 << endl;
    }

    fout.close();

    return 0;
}
