/* GCC */
#include <cstdio>
#include <algorithm>
#include <vector>
#define pi pair<short, short>
#define y first
#define x second

using namespace std;

struct sq {
    pi st; short sz;
    bool operator < (const sq &sqr) const {
        if(this->st.x < sqr.st.x) return true;
        if(this->st.x > sqr.st.x) return false;
        if(this->st.y < sqr.st.y) return true;
        if(this->st.y > sqr.st.y) return false;
        if(this->sz < sqr.sz) return true;
        return false;
    }
};
vector<pi> pts;
vector<sq> sqs;
sq res[2];

short n, i, j, k, yi, xi;
char c[1002][1002];
bool used[1002][1002];
sq tmpsq;

inline void apply_used(sq sqr) {
    for(yi = sqr.st.y, xi = sqr.st.x; xi < sqr.st.x + sqr.sz; xi++) {
        used[yi][xi] = true;
    }
    for(yi = sqr.st.y, xi = sqr.st.x; yi < sqr.st.y + sqr.sz; yi++) {
        used[yi][xi] = true;
    }
    for(yi = sqr.st.y + sqr.sz - 1, xi = sqr.st.x; xi < sqr.st.x + sqr.sz; xi++) {
        used[yi][xi] = true;
    }
    for(yi = sqr.st.y, xi = sqr.st.x + sqr.sz - 1; yi < sqr.st.y + sqr.sz; yi++) {
        used[yi][xi] = true;
    }
}

inline bool check_all_used() {
    for(long _i = 0; _i < pts.size(); _i++) {
        if(!used[pts[_i].y][pts[_i].x]) {
            return false;
        }
    }
    return true;
}

int main() {
    freopen("squares.in", "r", stdin);
    freopen("squares.out", "w", stdout);

    scanf("%d\n", &n);
    for(i = 1; i <= n; i++) {
        scanf("%c", c[i] + 1);
        if(c[i][1] == '#') {
            pts.push_back(make_pair(i, 1));
        }
        for(j = 2; j <= n; j++) {
            scanf(" %c", c[i] + j);
            if(c[i][j] == '#') {
                pts.push_back(make_pair(i, j));
            }
        }
        scanf("\n");
    }

    for(i = 0; i < pts.size(); i++) {
        tmpsq.st = pts[i]; tmpsq.sz = 2;
        for(yi = pts[i].y + 1, xi = pts[i].x + 1; yi <= n && xi <= n; yi++, xi++, tmpsq.sz++) {
            if(c[pts[i].y][xi] != '#' || c[yi][pts[i].x] != '#') break;

            if(tmpsq.sz > 2) {
                 bool flag = true;
                 for(j = 1; j < tmpsq.sz; j++) {
                       if(c[yi][pts[i].x + j] != '#') {
                             flag = false;
                             break;
                       }
                 }
                 if(flag) {
                     for(j = 1; j < tmpsq.sz; j++) {
                          if(c[pts[i].y + j][xi] != '#') {
                              flag = false;
                              break;
                          }
                     }
                 }

                 if(flag) {
                     sqs.push_back(tmpsq);
                 }
            }
        }
    }

    for(i = 0; i < sqs.size(); i++) {
        for(j = 1; j <= n; j++) {
            for(k = 1; k <= n; k++) {
                used[i][j] = false;
            }
        }
        apply_used(sqs[i]);

        if(check_all_used()) {
            res[0] = res[1] = sqs[i];
            break;
        }

        for(j = i + 1; j < sqs.size(); j++) {
            apply_used(sqs[i]);
            apply_used(sqs[j]);
            if(check_all_used()) {
                res[0] = sqs[i];
                res[1] = sqs[j];
                goto exit;
            }
        }
    }

exit:
    sort(res, res + 2);

    for(i = 0; i < 2; i++) {
        printf("%d %d %d %d\n", res[i].st.x, res[i].st.y, res[i].st.x + res[i].sz - 1, res[i].st.y + res[i].sz - 1);
    }

    return 0;
}
