/* GCC */
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

const int NMAX = 1010;
typedef struct
{
    int i, j, len;
} square;

int n;
char a[NMAX][NMAX];
vector <int> FIRST(4, 0), SECOND(4, 0);
int color[NMAX][NMAX];
square sq[100000];

int main()
{
    freopen("squares.in", "r", stdin);
    freopen("squares.out", "w", stdout);

    for (int i = 0; i < NMAX; ++i)
        for (int j = 0; j < NMAX; ++j)
            a[i][j] = '.';

    scanf("%d", &n);
    for (int i = 1; i <= n; ++i)
    {
        int j = 1;
        char c;
        while (j <= n)
        {
            c = getchar();
            if (c == '.' || c == '#')
                    a[i][j++] = c;
        }
    }

    int sz = 0;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            if (a[i][j] == '#' && a[i + 1][j] == '#' && a[i][j + 1] == '#')
            {
                int ii = i, jj = j;
                while (ii <= n && jj <= n && a[ii][j] == '#' && a[i][jj] == '#')
                {
                    if (a[ii][j+1] == '#' && a[i+1][jj] == '#' && ii - i + 1 > 2)
                    {
                        square add; add.i = i, add.j = j, add.len = ii - i + 1;
                        sq[sz++] = add;
                    }
                    ++ii, ++jj;
                }
            }

    bool ready = false;
    int FS = -1, SC = -1;
    for (int fs = 0; fs < sz && !ready; ++fs)
        for (int sc = fs; sc < sz; ++sc)
        {
            memset(color, 0, sizeof(color));
            for (int i = 1; i <= n; ++i)
                for (int j = 1; j <= n; ++j)
                    color[i][j] = (a[i][j] == '.' ? 1 : 0);

            square A = sq[fs];
            int ii = A.i + A.len - 1, jj = A.j + A.len - 1;
            for (int i = 0; i < A.len;++i)
                color[A.i + i][A.j] = color[A.i][A.j + i] = color[ii][jj - i] = color[ii - i][jj] = 1;

            A = sq[sc];
            ii = A.i + A.len - 1, jj = A.j + A.len - 1;
            for (int i = 0; i < A.len; ++i)
                color[A.i + i][A.j] = color[A.i][A.j + i] = 1, color[ii][jj - i] = color[ii - i][jj] = 1;

            ready = true;
            for (int i = 1; i <= n && ready; ++i)
                for (int j = 1; j <= n && ready; ++j)
                    if (!color[i][j])
                        ready = false;
            if (ready)
                FS = fs, SC = sc, fs = sc = sz;
        }

    FIRST[1] = sq[FS].i;
    FIRST[0] = sq[FS].j;
    FIRST[3] = sq[FS].i + sq[FS].len - 1;
    FIRST[2] = sq[FS].j + sq[FS].len - 1;
    SECOND[1] = sq[SC].i;
    SECOND[0] = sq[SC].j;
    SECOND[3] = sq[SC].i + sq[SC].len - 1;
    SECOND[2] = sq[SC].j + sq[SC].len - 1;

    for (int i = 0; i < 4; ++i)
        if (FIRST[i] < SECOND[i])
            i = 4;
        else
            if (FIRST[i] > SECOND[i])
                FIRST.swap(SECOND), i = 4;

    for (int i = 0; i < 3; ++i)
        printf("%d ", FIRST[i]);
    printf("%d\n", FIRST[3]);
    for (int i = 0; i < 3; ++i)
        printf("%d ", SECOND[i]);
    printf("%d\n", SECOND[3]);

    return 0;
}
